;; original name logistics.c
;; (:length (:parallel 13))
;; optimal
;; #actions 63 #states 10^10
;;

(define (problem log006)
    (:domain logistics-metric)
    (:length (:parallel 13))
  (:domain-variables
	(?dist[la-airport,la-airport] 0)
	(?dist[bos-airport,bos-airport] 0)
	(?dist[pgh-airport,pgh-airport] 0)
	(?dist[ny-airport,ny-airport] 0)
	(?dist[pgh-airport,la-airport] 2100)
	(?dist[pgh-airport,bos-airport] 500)
	(?dist[pgh-airport,ny-airport] 300)
	(?dist[la-airport,bos-airport] 2600)
	(?dist[la-airport,pgh-airport] 2100)
	(?dist[la-airport,ny-airport] 2500)
	(?dist[bos-airport,pgh-airport] 500)
	(?dist[bos-airport,la-airport] 2600)
	(?dist[bos-airport,ny-airport] 200)
	(?dist[ny-airport,pgh-airport] 300)
	(?dist[ny-airport,la-airport] 2500)
	(?dist[ny-airport,bos-airport] 200)
	(?capacity[airplane1] 400)
	(?capacity[airplane2] 2000)
	(?capacity[pgh-truck] 100)
	(?capacity[bos-truck] 100)
	(?capacity[la-truck] 100)
	(?capacity[ny-truck] 100)
	(?truck_trip 20)
	(?airplane_trip 50)
	(?plane_mpg 3) - float
	(?fuel[airplane1] 100)
	(?fuel[airplane2] 100)
	(?fuel[pgh-truck] 20)
	(?fuel[bos-truck] 20)
	(?fuel[la-truck] 20)
	(?fuel[ny-truck] 20)
	             - fluent)
    (:objects
        package1
        package2
        package3
        package4
        package5
        package6
        package7
	     - OBJ

        airplane1
        airplane2
	     - AIRPLANE

        pgh
        bos
        la
        ny
	     - CITY

        pgh-truck
        bos-truck
        la-truck
        ny-truck
	     - TRUCK

        pgh-po
        bos-po
        la-po
        ny-po

        pgh-central
        bos-central
        la-central
        ny-central
	     - LOCATION

        pgh-airport
        bos-airport
        la-airport
        ny-airport
	     - AIRPORT
    )
    (:init
	   (depot bos-airport)
	   (depot pgh-airport)
	   (depot la-airport)
	   (depot ny-airport)

        (in-city pgh-po pgh)
        (in-city pgh-airport pgh)
        (in-city pgh-central pgh)

        (in-city bos-po bos)
        (in-city bos-airport bos)
        (in-city bos-central bos)

        (in-city la-po la)
        (in-city la-airport la)
        (in-city la-central la)

        (in-city ny-po ny)
        (in-city ny-airport ny)
        (in-city ny-central ny)

        (at package1 pgh-po)
        (at package2 pgh-po)
        (at package3 pgh-po)
        (at package4 ny-po)
        (at package5 bos-po)
        (at package6 bos-po)
        (at package7 ny-po)

        (at airplane1 pgh-airport)
        (at airplane2 pgh-airport)

        (at bos-truck bos-po)
        (at pgh-truck pgh-po)
        (at la-truck la-po)
        (at ny-truck ny-po)

    )
    (:goal (and
        (at package1 bos-po)
        (at package2 ny-po)
        (at package3 la-po)
        (at package4 la-airport)
        (at package5 pgh-po)
        (at package6 ny-airport)
        (at package7 pgh-po)
    ))
)
