;; original name logistics.easy
;;
;; These distances are actually close to accurate (how useful is that!).

(define (problem easy1)
    (:domain logistics-metric)
    (:length (:parallel 9))
    (:domain-variables
     ;; Define all the connections in the city graph
	(?dist[bos-airport,bos-airport] 0)
	(?dist[pgh-airport,pgh-airport] 0)
	(?dist[pgh-airport,bos-airport] 800)
	(?dist[bos-airport,pgh-airport] 800)

	;; Amount of fuel the vehicles can carry (max).
	(?capacity[airplane1] 400)
	(?capacity[pgh-truck] 100)
	(?capacity[bos-truck] 100)

	;; How much fuel does one leg of a truck's trip take?
	(?truck_trip 20)

	;; How much fuel (minimum) does one leg of an airplane trip take?
	;; (Simulates takeoff/landing)
	(?airplane_trip 50)

	;; Miles per gallon of fuel for the plane.
	(?plane_mpg 3) - float

	;; Initial fuel levels.
	(?fuel[airplane1] 100)
	(?fuel[pgh-truck] 20)
	(?fuel[bos-truck] 20)
	             - fluent)
    (:objects
        package1
        package2
	     - OBJ

        airplane1
	     - AIRPLANE

        pgh
        bos
	     - CITY

        pgh-truck
        bos-truck
          - TRUCK

        pgh-po
        bos-po
	     - LOCATION

        pgh-airport
        bos-airport
	     - AIRPORT
    )
    (:init
	   (depot pgh-airport)
	   (depot bos-airport)

        (in-city pgh-po pgh)
        (in-city pgh-airport pgh)

        (in-city bos-po bos)
        (in-city bos-airport bos)

        (at package1 pgh-po)
        (at package2 pgh-po)

        (at airplane1 pgh-airport)

        (at bos-truck bos-po)
        (at pgh-truck pgh-po)
    )
    (:goal (and
        (at package1 bos-po)
        (at package2 bos-po)
    ))
)

