;; original name logistics.d
;; (:length (:parallel 15)) extra step from resource constraints
;;

(define (problem log007)
    (:domain logistics-metric)
    (:length (:parallel 15))
  (:domain-variables
	(?dist[la-airport,la-airport] 0)
	(?dist[bos-airport,bos-airport] 0)
	(?dist[pgh-airport,pgh-airport] 0)
	(?dist[ny-airport,ny-airport] 0)
	(?dist[sf-airport,sf-airport] 0)
	(?dist[pgh-airport,la-airport] 2100)
	(?dist[pgh-airport,bos-airport] 500)
	(?dist[pgh-airport,ny-airport] 300)
	(?dist[pgh-airport,sf-airport] 2300)
	(?dist[la-airport,bos-airport] 2600)
	(?dist[la-airport,pgh-airport] 2100)
	(?dist[la-airport,ny-airport] 2500)
	(?dist[la-airport,sf-airport] 300)
	(?dist[bos-airport,pgh-airport] 500)
	(?dist[bos-airport,la-airport] 2600)
	(?dist[bos-airport,ny-airport] 200)
	(?dist[bos-airport,sf-airport] 2700)
	(?dist[ny-airport,pgh-airport] 300)
	(?dist[ny-airport,la-airport] 2500)
	(?dist[ny-airport,bos-airport] 200)
	(?dist[ny-airport,sf-airport] 2600)
	(?dist[sf-airport,pgh-airport] 2300)
	(?dist[sf-airport,la-airport] 300)
	(?dist[sf-airport,bos-airport] 2700)
	(?dist[sf-airport,ny-airport] 2600)
	(?capacity[airplane1] 400)
	(?capacity[airplane2] 2000)
	(?capacity[pgh-truck] 100)
	(?capacity[bos-truck] 100)
	(?capacity[la-truck] 100)
	(?capacity[ny-truck] 100)
	(?capacity[sf-truck] 100)
	(?truck_trip 20)
	(?airplane_trip 50)
	(?plane_mpg 3) - float
	(?fuel[airplane1] 100)
	(?fuel[airplane2] 100)
	(?fuel[pgh-truck] 20)
	(?fuel[bos-truck] 20)
	(?fuel[la-truck] 20)
	(?fuel[ny-truck] 20)
	(?fuel[sf-truck] 20)
	             - fluent)
    (:objects
        package1
        package2
        package3
        package4
        package5
        package6
        package7
        package8
        package9
	     - OBJ

        airplane1
        airplane2
	     - AIRPLANE

        pgh
        bos
        la
        ny
        sf
	     - CITY

        pgh-truck
        bos-truck
        la-truck
        ny-truck
        sf-truck
	     - TRUCK

        pgh-po
        bos-po
        la-po
        ny-po
        sf-po

        pgh-central
        bos-central
        la-central
        ny-central
        sf-central
	     - LOCATION

        pgh-airport
        bos-airport
        la-airport
        ny-airport
        sf-airport
	     - AIRPORT
    )
    (:init
	   (depot bos-airport)
	   (depot pgh-airport)
	   (depot la-airport)
	   (depot ny-airport)
	   (depot sf-airport)

        (in-city pgh-po pgh)
        (in-city pgh-airport pgh)
        (in-city pgh-central pgh)

        (in-city bos-po bos)
        (in-city bos-airport bos)
        (in-city bos-central bos)

        (in-city la-po la)
        (in-city la-airport la)
        (in-city la-central la)

        (in-city ny-po ny)
        (in-city ny-airport ny)
        (in-city ny-central ny)

        (in-city sf-po sf)
        (in-city sf-airport sf)
        (in-city sf-central sf)

        (at package1 pgh-po)
        (at package2 pgh-central)
        (at package3 pgh-central)
        (at package4 ny-po)
        (at package5 bos-po)
        (at package6 bos-po)
        (at package7 ny-po)
        (at package8 sf-airport)
        (at package9 sf-central)

        (at airplane1 pgh-airport)
        (at airplane2 pgh-airport)

        (at bos-truck bos-po)
        (at pgh-truck pgh-airport)
        (at la-truck la-po)
        (at ny-truck ny-central)
        (at sf-truck sf-airport)
    )
    (:goal (and
       (at package1 bos-po)
       (at package2 ny-po)
       (at package3 la-central)
       (at package4 la-airport)
       (at package5 pgh-po)
       (at package6 ny-central)
       (at package7 pgh-po)
       (at package8 ny-central)
       (at package9 sf-po)
    ))
)
