# 1 "Maison.task" 






# 1 "./Maison-relations" 1






constant BOOLEEN   = {faux, vrai};

constant MURS      = {m1,m2,m3,m4};

constant ROBOTS    = {plombier, electricien, decorateur};
constant TABLES    = {table1, table2, table3};

constant OUTILS           = {tournevis, marteau, burin, 
	                     fer_a_souder, pinceau, truelle};
constant CONTENANTS        = {seau, boite_a_outils};
constant PETITS_OBJETS    = OUTILS | CONTENANTS;
constant GROS_OBJETS      = TABLES | {echelle};
constant OBJETS           = PETITS_OBJETS | GROS_OBJETS;

constant ENDROITS  = {devantMur1, devantMur2, devantMur3, 
		      devantMur4, milieu_piece};

constant LIEUX     =  ENDROITS | CONTENANTS | TABLES | ROBOTS;
constant LAIES     = {laie1, laie2, laie3, laie4};





attribute ARRIVEE_EAU(){
    ?value  in {coupee, non_coupee};
}

attribute ARRIVEE_ELEC(){
    ?value in {coupee, non_coupee};
}

attribute ALIMENTER_EN_EAU(?mur){
    ?mur  in MURS;
    ?value in  BOOLEEN;
}    

attribute ALIMENTER_EN_ELEC(?mur){
    ?mur  in MURS;
    ?value in  BOOLEEN;
}    

attribute SAIGNEE_EAU(?mur){
    ?mur  in MURS;
    ?value in  {non_creusee, creusee, remplie, bouchee, en_preparation};
}

attribute SAIGNEE_ELEC(?mur){
    ?mur  in MURS;
    ?value in  {non_creusee, creusee, remplie, bouchee, en_preparation};
}

attribute UTILISE(?objet){
    ?objet in OBJETS ;
    ?value in BOOLEEN;
}

attribute CONTENU_BRAS(?robot){
    ?robot in ROBOTS;
    ?value in PETITS_OBJETS | { rien };
}

attribute PLACE(?objet){
    ?objet in PETITS_OBJETS;
    ?value   in LIEUX;
}

attribute POSITION(?objet){
    ?objet   in OBJETS | ROBOTS;
    ?value   in ENDROITS;
}

attribute ETAT_MUR(?mur){
    ?mur   in MURS;
    ?value in  {propre, sale, tapisse};
}

attribute ETAT_TABLE(?table){
    ?table in TABLES;
    ?value in  {libre, occupee};
}

attribute ETAT_CONTENANT(?contenant){
    ?contenant in CONTENANTS;
    ?value in  {vide, non_vide};
}

attribute MUR_ACCESSIBLE(?mur){
    ?mur   in MURS;
    ?value in BOOLEEN;
}

attribute DISPONIBLE(?robot){
    ?robot in ROBOTS;
    ?value in BOOLEEN;
}

attribute ETAT_LAIE(?laie){
    ?laie in LAIES;
	?value in { non_encolee, encolee, posee};
}





resource COLLE ()
{
    capacity = 0;
}

resource PLATRE ()
{
    capacity = 0;
}

resource CABLES ()
{
    capacity = 3;
}

resource TUYAUX_EAU ()
{
    capacity = 3;
}


































# 8 "Maison.task" 2





# 1 "./saisie.task" 1




task saisir_objet(?robot, ?objet, ?lieu) (start,end){

    ?objet in PETITS_OBJETS; ?robot in ROBOTS; ?lieu  in LIEUX;
    timepoint t;
    variable ?endroit; ?endroit in ENDROITS;

    event(DISPONIBLE(?robot):(faux,vrai),start);
    hold(DISPONIBLE(?robot):vrai, (start,end));
    event(DISPONIBLE(?robot):(vrai,faux),end);	  

    hold( POSITION(?robot):?endroit, (start,end));
    hold( POSITION(?objet):?endroit, (start,end));

    if( ?lieu in TABLES | CONTENANTS )
	hold( POSITION(?lieu):?endroit, (start,end));

    hold( PLACE(?objet): ?lieu, (start,t));
    event( PLACE(?objet): (?lieu, ?robot), t);
    hold( PLACE(?objet): ?robot, (t,end)); 

    hold(CONTENU_BRAS(?robot): rien, (start,t));
    event(CONTENU_BRAS(?robot): (rien,?objet), t);
    hold(CONTENU_BRAS(?robot): ?objet, (t,end));

    if(?lieu in TABLES) {
	variable ?o, ?e;
	?o in PETITS_OBJETS; ?e in LIEUX;

	if( forall(?o) exists(?e) (
	            hold(PLACE(?o):?e, (t,end)) && ?e != ?lieu)){
	    hold(ETAT_TABLE(?lieu):occupee, (start, t));
	    event(ETAT_TABLE(?lieu): (occupee, libre), t);
	    hold(ETAT_TABLE(?lieu): libre, (t,end));
	}
    }

    if(?lieu in CONTENANTS){
	variable ?o, ?e;
	?o in OUTILS; ?e in LIEUX;

	if( forall(?o) exists(?e) (
	            hold(PLACE(?o):?e, (t,end)) && ?e != ?lieu)){
	    hold(ETAT_CONTENANT(?lieu):non_vide, (start, t));
	    event(ETAT_CONTENANT(?lieu): (non_vide, vide), t);
	    hold(ETAT_CONTENANT(?lieu): vide, (t,end));
	} 
    }

   (end - t) in [0.30, 1:00];
    (t - start) in [0.30, 1:00];  
    main PLACE;
}



































 










    


task vider_table(?robot, ?table, ?endroit) (start,end)
{
    ?robot in ROBOTS;
    ?table in TABLES;
    ?endroit in ENDROITS;

    timepoint t;
    start < t < end;

    hold(ETAT_TABLE(?table): occupee, (start,end));
    event(ETAT_TABLE(?table): (occupee,libre), end);

    variable ?objet in PETITS_OBJETS;

	if( hold(PLACE(?objet): ?table, (start,t) ))
	    { variable ?lieu in LIEUX;
	      timepoint t1,t2; 
	      ?lieu != ?table;

  	      task saisir_objet(?robot,?objet,?table) (t1,t2);

	      t < t1 < t2 < end; 
	    }

    main ETAT_TABLE;
}
# 14 "Maison.task" 2



























