;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; fly world
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(define (domain fly)
  (:requirements :strips)
  (:domain-variables
   (?speed 400)
   (?fill_rate 750)
   (?fuel_capacity 750)
   (?mpg 3) - float
   (?time 0) - fluent)
  (:action fly
		 :parameters (?from ?to - AIRPORT)
		 :precondition (and (plane-at ?from)
						(test ?fuel' >= 0))
		 :effect (and (not (plane-at ?from))
				    (plane-at ?to)
				    (forall (?p - PASSENGER)
						  (when (boarded ?p)
							   (and (not (at ?p ?from))
								   (at ?p ?to))))
				    (influence ?fuel -?dist[?from,?to] / ?mpg)
				    (influence ?time ?dist[?from,?to] / ?speed)))
  (:action refuel
		 :parameters (?where - AIRPORT)
		 :precondition (plane-at ?where)
		 :effect (and (set ?fuel ?fuel_capacity)
				    (influence ?time (?fuel_capacity - ?fuel) / ?fill_rate)))
  (:action board
		 :parameters (?where - AIRPORT)
		 :precondition (plane-at ?where)
		 :effect (forall (?p - PASSENGER)
					  (when (and (at ?p ?where)
							   (checked-in ?p))
						   (and (not (checked-in ?p))
							   (boarded ?p)))))
  (:predicates (plane-at ?loc - AIRPORT)
			(boarded ?p - PASSENGER)
			(checked-in ?p - PASSENGER)
			(at ?p - PASSENGER ?where - AIRPORT))
  )


