;; logistics domain
;;
;; logistics-strips: pure strips, no types, no equality
;;    Compatible with problem instances for the domain01.pddl 
;;    from the PDDL 1.3 distribution.
;;    Fixes a few missing parameter predicates and
;;    has unload truck and plane as separate operators
;;    (as in original formulation).
;;    12 June 1998, Bart Selman & Henry Kautz
;;
;;    13 Oct 1998, Steve Wolfman - modified to metricize (include 
;;                                 metric effects/preconditions/parms)
;;
;; Question: should airplanes have a separate (at ?a - AIRPLANE ?l - AIRPORT)?
;;
;; Note: changed so that planes can load and unload only at airports.
;;       only possible problem I can think of with this is if AIRPLANEs
;;       can be OBJs (and moved around be trucks... cool thought!)
;;

(define (domain logistics-metric)
  (:requirements :strips) 
  (:types LOCATION CITY MOVEABLE - OBJECT OBJ TRUCK - MOVEABLE)
  (:predicates 	(at ?obj - MOVEABLE ?loc - LOCATION)
				(in ?obj - OBJ ?obj - TRUCK)
				(in-city ?loc - LOCATION ?city - CITY))
  
  (:action LOAD-TRUCK
		 :parameters
		 (?obj - OBJ
		  ?truck - TRUCK
		  ?loc - LOCATION)
		 :precondition
		 (and (at ?truck ?loc) (at ?obj ?loc))
		 :effect
		 (and (not (at ?obj ?loc)) (in ?obj ?truck)))
  
;  (:action UNLOAD-TRUCK
;		 :parameters
;		 (?obj - OBJ
;		  ?truck - TRUCK
;		  ?loc - LOCATION)
;		 :precondition
;		 (and (at ?truck ?loc) (in ?obj ?truck))
;		 :effect
;		 (and (not (in ?obj ?truck)) (at ?obj ?loc)))
  
;  (:action DRIVE-TRUCK
;		 :parameters
;		 (?truck - TRUCK
;		  ?loc-from - LOCATION
;		  ?loc-to - LOCATION
;		  ?city - CITY)
;		 :precondition
;		 (and (at ?truck ?loc-from)
;			 (in-city ?loc-from ?city)
;			 (in-city ?loc-to ?city)
;			 (test ?fuel[?truck] >= ?truck_trip))
;		 :effect
;		 (and (not (at ?truck ?loc-from)) (at ?truck ?loc-to) 
;			 (set ?fuel[?truck] ?fuel[?truck] - ?truck_trip)))
  )
