;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; Party world thanks to Jana Koehler, appears to
;;; be based on Corin Anderson's movie watching domain.
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(define (domain party)
  (:requirements :strips)
  (:types location item - object store - location)
  (:action go
		 :parameters (?from ?to - location)
		 :precondition (at ?from)
		 :effect (and (at ?to)
				    (not (at ?from))
				    (set ?time ?time + ?distance[?from,?to] / 5)))
  (:action buy
		 :parameters (?i - item ?at - store)
		 :precondition (and (at ?at)
						(in-shop ?at ?i)
						(test ?money >= ?price[?at,?i]))
		 :effect (and (has ?i)
				    (set ?amount[?i] ?amount[?i] + 1)
				    (set ?time ?time + 60)
				    (set ?money ?money - ?price[?at,?i])))
  (:predicates (at ?loc - location)
			(in-shop ?loc - store ?item - item)
			(has ?item - item)))
