;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; robot blocks world
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(define (domain robot-blocks)
  (:requirements :strips)
  (:constants Table - BLOCK)
  (:action fuel-puton
		 :parameters (?robot - ROBOT ?object ?source ?dest - BLOCK)
		 :precondition (and (on ?object ?source)
						(clear ?dest)
						(clear ?object)
						(test ?fuel[?robot] >= ?size[?object])
						(not (= ?source ?dest))
						(not (= ?object ?dest))
						(not (= ?object ?source))
						(not (= ?object Table)))
		 :effect (and (set ?fuel[?robot] ?fuel[?robot] - ?size[?object])
				    (on ?object ?dest)
				    (not (on ?object ?source))
				    (clear ?source)
				    (when (not (= ?dest Table))
						(not (clear ?dest)))))
  (:action government-fuel-puton
		 :parameters (?robot - ROBOT ?object ?source ?dest - BLOCK)
		 :precondition (and (on ?object ?source)
						(clear ?dest)
						(clear ?object)
						(test ?fuel[?robot] >= 2*?size[?object])
						(not (= ?source ?dest))
						(not (= ?object ?dest))
						(not (= ?object ?source))
						(not (= ?object Table)))
		 :effect (and (set ?fuel[?robot] ?fuel[?robot] - 2*?size[?object])
				    (on ?object ?dest)
				    (not (on ?object ?source))
				    (clear ?source)
				    (when (not (= ?dest Table))
						(not (clear ?dest)))))
  (:predicates (on ?top ?bottom - BLOCK)
			(clear ?block - BLOCK))
  )


