;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; truck world
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(define (domain truck)
  (:requirements :strips)
  (:domain-variables
   (?fast_speed 60)
   (?slow_speed 30)
   (?fast_mpg 20)
   (?slow_mpg 60) - float
   (?time 0) - fluent)
  (:action slow-move
		 :parameters (?from ?to)
		 :precondition (and (att ?from)
						(test (?fuel - ?dist[?from,?to] / ?slow_mpg) 
							 >= 0)
						(connected ?from ?to))
		 :effect (and (not (att ?from))
				    (att ?to)
				    (set ?fuel (?fuel - ?dist[?from,?to] / ?slow_mpg))
				    (set ?time (?time + ?dist[?from,?to] / ?slow_speed))))
  (:action fast-move
		 :parameters (?from ?to)
		 :precondition (and (att ?from)
						(test (?fuel - ?dist[?from,?to] / ?fast_mpg) 
							 >= 0)
						(connected ?from ?to))
		 :effect (and (not (att ?from))
				    (att ?to)
				    (set ?fuel (?fuel - ?dist[?from,?to] / ?fast_mpg))
				    (set ?time (?time + ?dist[?from,?to] / ?fast_speed))))
  (:predicates (att ?loc)
			(connected ?x ?y))

)


