;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; truck world
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


(define (domain truck)
  (:requirements :strips)
  (:action move
		 :parameters (?from ?to)
		 :fluent-parameters (?inv_speed ?gpm)
		 :precondition (and (att ?from)
						(test ?inv_speed <= 1/?min_speed)
						(test ?inv_speed >= 1/?max_speed)
						(test (?fuel - ?dist[?from,?to] * ?gpm) >= 0)
						(connected ?from ?to))
		 :effect (and (not (att ?from))
				    (att ?to)
				    (when (test ?inv_speed <= 1/?break_speed)
						(set ?gpm 1/?fast_mpg))
				    (when (test ?inv_speed >= 1/?break_speed)
						(set ?gpm 1/?slow_mpg))
				    (set ?fuel (?fuel - ?dist[?from,?to] * ?gpm))
				    (set ?time (?time + ?dist[?from,?to] * ?inv_speed))))
  (:domain-variables 
   (?min_speed 20)
   (?max_speed 120)
   (?break_speed 60)
   (?fast_mpg 20)
   (?slow_mpg 60) - float
   (?time 0) - fluent
   (?fuel 8) - fluent
   (?dist[A,B] 400)
   (?dist[B,A] 400)
   (?dist[A,C] 500)
   (?dist[C,A] 500)
   (?dist[B,C] 300)
   (?dist[C,B] 300) 
   (?dist[A,A] 0)
   (?dist[B,B] 0)
   (?dist[C,C] 0) - float)
  (:predicates (att ?loc)
			(connected ?x ?y))

)


