;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; truck world with pickup/putdown
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(define (domain truck)
  (:requirements :strips)
  (:types LOC THING - OBJECT GLASS - THING)
  (:domain-variables
   (?speed 30)
   (?mpg 60) - float
   (?time 0) - fluent)
  (:action glass-power-up
		 :effect (glass-powered-up))
  (:action move
		 :parameters (?from ?to - LOC)
		 :precondition (and (att ?from)
						(test (?fuel - ?dist[?from,?to] / ?mpg) 
							 >= 0)
						(connected ?from ?to))
		 :effect (and (not (att ?from))
				    (att ?to)
				    (forall (?g - GLASS)
						  (when (and (not (glass-powered-up))
								   (in-truck ?g))
							   (broken ?g)))
				    (set ?fuel (?fuel - ?dist[?from,?to] / ?mpg))
				    (set ?time (?time + ?dist[?from,?to] / ?speed))))
  (:action pick-up
		 :parameters(?obj - THING ?loc - LOC)
		 :precondition (and (att ?loc)
						(at ?obj ?loc))
		 :effect (and (not (at ?obj ?loc))
				    (in-truck ?obj)))
  (:action put-down
		 :parameters(?obj - THING ?loc - LOC)
		 :precondition (and (in-truck ?obj)
						(att ?loc))
		 :effect (and (not (in-truck ?obj))
				    (at ?obj ?loc)))
  (:predicates (att ?loc - LOC)
			(at ?obj - THING ?loc - LOC)
			(connected ?x ?y - LOC)
			(in-truck ?obj - THING)
			(broken ?glass - GLASS)
			(glass-powered-up))

)


