#ifndef _SHARED_H
#define _SHARED_H

#include <string>
#include <hash_map>
#include <vector>

#include "stats.h"

#define ACTION_LABEL "ACTION-\0"
#define TIME_PREFIX "STEP\0"
#define CONSTRAINT_STR "TEST_SET\0"
#define TEST_STR "TEST\0"
#define SET_STR "SET\0"
#define INFLUENCE_STR "INFLUENCE\0"
#define CONNECTOR "~"  /* marks border between connected items */
#define VAR_INTERNAL_CONNECTOR "_" /* marks border between time label and 
							   variable name */
#define UNSAT_STR "UNSAT\0"

enum MAPPING_VALUE { MV_CONTRADICTION = -4, MV_DONT_CARE = -3, 
				 MV_FALSE = -2, MV_TRUE = -1 };

struct VAR_OCC {
  VAR_OCC() : pos(false), val(0) { }
  VAR_OCC(bool pos_, int val_) : pos(pos_), val(val_) { }
  bool pos;
  int val;
};

#ifndef HASH_STRING
#define HASH_STRING
struct hash<string>
{
  size_t operator()(const string & s) const {
    unsigned int i;
    size_t result = 0;
    for (i = 0; i < s.length(); i++) {
	 result <<= 1;
	 result += (size_t)s[i];
    }

    return result;
  }
};
#endif

typedef vector<VAR_OCC> CNF_CLAUSE;

#endif
