#ifndef _STATS_H
#define _STATS_H

#include <iostream.h>

class Stats {
public:
  enum Printables { MEAN = 0x1, STD = 0x2, MAX = 0x4, MIN = 0x8,
				COUNT = 0x10, TOTAL = 0x20 };

  Stats();

  void log(double data);
  void log(int data = 1) { log((double)data); }

  double mean();
  double std();
  double max();
  double min();
  double count();
  double total();

  void clear();

  friend ostream & operator << (ostream & out, Stats & stats);
  void setPrint(Printables print);

protected:
  
  int _count;
  double _total;
  double _squaredTotal;
  double _max;
  double _min;
  unsigned int _print;
};

#endif // _STATS_H
