// $Id: debug.h,v 1.1 1998/11/28 17:52:36 wolf Exp $
//
// Cassowary Incremental Constraint Solver
// Original Smalltalk Implementation by Alan Borning
// This C++ Implementation by Greg J. Badros, <gjb@cs.washington.edu>
// http://www.cs.washington.edu/homes/gjb
// (C) 1998 Alan Borning and Greg Badros
// See ../COPYRIGHT for legal details regarding this software
//
// debug.h

#ifndef CASSOWARY_DEBUG_H_
#define CASSOWARY_DEBUG_H_

#include "Cassowary.h"
#include <map>
#include <set>
#include <vector>
#include "ClLinearExpression_fwd.h"

class ClAbstractVariable;

ostream &operator<<(ostream &xo, const set<const ClAbstractVariable *> & varset);

ostream &operator<<(ostream &xo, const map<const ClAbstractVariable *, set<const ClAbstractVariable *> > & varmap);

ostream &operator<<(ostream &xo, const map<const ClAbstractVariable *, ClLinearExpression * > & rows);

ostream &operator<<(ostream &xo, const vector<const ClAbstractVariable *> &varlist);

class Tracer {
 public:
  Tracer(const char *const sz) : sz_(sz) { cerr << "* " << sz; }
  ~Tracer() { cerr << "x " << sz_ << " exited." << endl; }
 private:
  const char *const sz_;
};

#endif
